



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>8.5 filecmp--文件和文件夹比較处理</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">8.5 filecmp--文件和文件夹比較处理</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 22:16:32 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p>本模块主要提供了对文件和文件夹进行简单的比較处理，假设须要复杂的文件比較须要使用difflib库来处理。</p>
<p><strong>filecmp.cmp(f1, f2, shallow=True) </strong></p>
<p>比較文件f1和文件f2，当两个文件同样时返回True，否则返回False。假设參数shallow为True，仅仅推断os.stat()函数返回内容是否同样，假设同样就返回True。否则再比較文件内容是否同样，假设同样也返回True。使用shallow參数能够高速地比較文件是否有改动过。</p>
<p>样例：</p>
<p>#python 3.4</p>
<p>import filecmp</p>
<p>r = filecmp.cmp('F:\\temp\\py\\bisect2.py', 'F:\\temp\\py\\bisect2.py')</p>
<p>print(r)</p>
<p>r = filecmp.cmp('F:\\temp\\py\\bisect2.py', 'F:\\temp\\py\\cal_1.py')</p>
<p>print(r)</p>
<p>结果输出例如以下：</p>
<p>True</p>
<p>False</p>
<p><strong>filecmp.cmpfiles(dir1, dir2, common, shallow=True)</strong></p>
<p>比較两个文件夹里同样文件列表的文件。參数dir1是文件夹1，參数dir2是文件夹2。參数common是比較的文件列表。參数shallow是跟上面的函数是一样意义。</p>
<p>本函数执行之后返回三个文件名称列表：同样列表、不同样列表、错误列表。假设文件同样放在同样列表，不同样放不同样列表。假设文件不存在某一个文件夹。就放错误列表。</p>
<p>样例：</p>
<p>#python 3.4</p>
<p>import filecmp</p>
<p>dir1 = 'F:\\temp\\py\\dir1'</p>
<p>dir2 = 'F:\\temp\\py\\dir2'</p>
<p>r = filecmp.cmpfiles(dir1, dir2,</p>
<p>['difflib1.py', 'difflib5.py', 'test1.txt'])</p>
<p>print(r)</p>
<p>结果输出例如以下：</p>
<p>(['difflib1.py'], ['difflib5.py'], ['test1.txt'])</p>
<p><strong>filecmp.clear_cache() </strong></p>
<p>清除文件比較缓冲区。当比較的文件不断地高速改动时，就能够使用这个函数来更新文件的信息。</p>
<p><strong>class filecmp.dircmp(a, b, ignore=None, hide=None) </strong></p>
<p>构造一个新的文件夹比較对象，比較文件夹a和b。參数ignore是忽略列表，是指那些文件不须要进行比較的；參数hide是隐藏的文件列表，默认是[os.curdir, os.pardir]。</p>
<p>这个类主要提供以下的方法：</p>
<p>report()</p>
<p>打印a和b之间的比較结果到系统sys.stdout输出。</p>
<p>report_partial_closure()</p>
<p>打印文件夹a和b。以及公共的子文件夹的比較结果到系统sys.stdout输出。</p>
<p>report_full_closure()</p>
<p>递归全部目标，包含子文件夹，把结果比較输出。</p>
<p>left</p>
<p>内部表示文件夹a。</p>
<p>right</p>
<p>内部表示文件夹b。</p>
<p>left_list</p>
<p>内部表示文件夹a经过隐藏和忽略过滤的文件和子文件夹列表。</p>
<p>right_list</p>
<p>内部表示文件夹b经过隐藏和忽略过滤的文件和子文件夹列表。</p>
<p>common</p>
<p>文件夹a和b都有的公共文件和子文件夹。</p>
<p>left_only</p>
<p>仅在文件夹a出现的文件和子文件夹。</p>
<p>right_only</p>
<p>仅在文件夹b出现的文件和子文件夹。</p>
<p>common_dirs</p>
<p>在文件夹a和文件夹b都出现的子文件夹。</p>
<p>common_files</p>
<p>在文件夹a和文件夹b都出现的文件。</p>
<p>common_funny</p>
<p>比較文件夹a和b不同的文件夹或文件。通过os.stat()比較。</p>
<p>same_files</p>
<p>比較文件夹a和b同样的文件夹或文件。</p>
<p>diff_files</p>
<p>比較文件夹a和b不同的文件夹或文件。通过文件内容比較。</p>
<p>funny_files</p>
<p>不进行比較的文件。</p>
<p>subdirs</p>
<p>子文件夹字典。</p>
<p>filecmp.DEFAULT_IGNORES</p>
<p>须要忽略的文件列表。</p>
<p>样例：</p>
<p>from filecmp import dircmp</p>
<p>def print_diff_files(dcmp):</p>
<p>for name in dcmp.diff_files:</p>
<p>print(&quot;diff_file %s found in %s and %s&quot; % (name, dcmp.left,</p>
<p>dcmp.right))</p>
<p>for sub_dcmp in dcmp.subdirs.values():</p>
<p>print_diff_files(sub_dcmp)</p>
<p>dcmp = dircmp('dir1', 'dir2')</p>
<p>print_diff_files(dcmp)</p>
<p>在这个样例里，主要比較文件夹dir1和dir2，为此创建了dircmp对象dcmp，然后调用函数print_diff_files()。在这个函数里主要打印输出不同的文件，并递归到子文件夹里打印子文件夹里不同的文件输出。</p>
<p>蔡军生 QQ:9073204 &nbsp;深圳</p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qx4x3e9.html">Unity官网教程之Tips</a>
		</li>
						<li><a href="https://www.batexi.com/a/390lnoj9.html">HTML之：让网页中的&amp;lt&semi;a&amp;gt&semi;标签属性统一设置-如&OpenCurlyQuote;新窗口打开&rsquo;</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2e133q.html">WebApi 2：属性路由 &lbrack;Route&lpar;&rpar;&rsqb;，attribute routing</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1jvjn9.html">itextsharp去掉PDF加密</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgkyr48.html">svn的简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj4xdk8.html">Android打开&sol;data&sol;目录以及导出文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzg10e8.html">msfconsole弄外网手机木马</a>
		</li>
						<li><a href="https://www.batexi.com/a/950y3re8.html">GDKOI2016 游记</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj2mre9.html">centos7下安装apache服务器httpd的yum方式安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo7mpxq.html">hive中与hbase外部表join时内存溢出（hive处理mapjoin的优化器机制）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwmlmd8.html">&lbrack;poj1160&rsqb;&lbrack;IOI2000&rsqb;Post Office【动态规划】</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25vo43q.html">05 Zabbix triggers--action--event</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ow3me8.html">POI导出Excel&lpar;xls、xlsx均可以，也支持图片&rpar;&mdash;&mdash;（三）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4dlxe9.html">一个DELPHI操作USB摄像头类</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppd5nz9.html">JS条件判断</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kkxwoq.html">VMWare&colon; eth0&colon; error fetching interface information &colon; device not found</a>
		</li>
						<li><a href="https://www.batexi.com/a/qve3ppz9.html">自制session</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn32edq.html">定时登录下载sftp服务器上的某些有规则的文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpl72e9.html">JSTL核心标签</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwok3jl9.html">虚拟机VMware搭建代码环境</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qxkzzgd8.html">在浏览器里点击input输入框输入，会展示默认的历史下拉菜单</a>
			</li>
						<li><a href="https://www.batexi.com/a/93ygkgg8.html">SQL Server 审计</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnj4ky38.html">在微信端使用video标签，播放结束会出现QQ浏览器推荐视频的解决办法（vue）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpr6o39.html">HTML出现错位的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy10n42q.html">移动端（H5）弹框组件--简单--实用--不依赖jQuery</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzd4n48.html">Tornado异步</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpre539.html">微信JS-SDK 选取手机照片并进行上传</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzdolw8.html">python 常用库整理</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kw7e59.html">一道变态的Javascript面试题</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojle6eq.html">基于FPGA的有限状态机浅析</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
